<template>
  <template v-if="node.concept && node.children.length < 1"></template>
  <template v-else>
    <q-card v-intersection="scrollObserver"
            v-if="node" class="q-ml-sm q-pt-xs" flat v-bind:id="'detail_' + node.id"
            role="presentation">
      <template v-if="is_concept(node)">
        <div class="text-h6 q-pl-sm presentation_label" ref="node.id" :key="language_switch" v-html="show_label(node)" role="heading">
        </div>
      </template>
      <template v-else>
        <q-card-section class="section_heading__border text-weight-bold" :key="language_switch" role="heading">
          <div v-html="show_label(node)"></div>
        </q-card-section>
        <template v-if="node.tables || node.hypercube">
          <q-intersection once class="dummy_table">
            <HtmlTable v-bind:linkrole_id="node.linkrole_id"
                       v-bind:dts_name="dts_name"
                       v-bind:linkrole_role_uri="node.linkrole_role_uri"
                       v-bind:nt_version="nt_version"
                       v-on:nodeClicked="nodeClicked">
            </HtmlTable>
          </q-intersection>
        </template>
        <template v-else>
          <LinkroleDetail :dts_name="dts_name" :linkrole_id="node.linkrole_id"></LinkroleDetail>
        </template>
      </template>
    </q-card>
      <TocDetailItem
        v-for="(node, index) in node.children"
        v-bind:key="index"
        ref="node.id"
        :node="node"
        :dts_name="dts_name"
        :nt_version="nt_version"
        v-on:nodeClicked="nodeClicked"
        v-on:tableVisible="childInView">
      </TocDetailItem>
  </template>
</template>

<script>
import LinkroleDetail from "components/LinkroleDetail";
import HtmlTable from "components/HtmlTable";
import SharedMethods from "components/SharedMethods";

export default {
  name: "TocDetailItem",
  components: {LinkroleDetail, HtmlTable},
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
  },
  mounted() {
    if (this.$route.hash && this.node) {
      if ('#' + this.node.id === this.$route.hash) {
        window.addEventListener('load', this.scrollToHash(this.$route))
      }
    }
  },
  props: {
    node: Object,
    dts_name: String,
    nt_version: String
  },
  emits: ['nodeClicked', 'tableVisible'],
  data() {
    return {
      language_switch: 0,
      scrollObserver: {handler: this.tableInView, cfg: {threshold: 0.75}}
    }
  },
  methods: {
    is_concept: function (node) {
      return node.node_type === 'concept'
    },
    nodeClicked: function (node) {
      this.$emit('nodeClicked', node)
    },
    scrollToHash: function (to) {
      if (this.node && '#' + this.node.id === to.hash) {
        let el = document.getElementById("detail_" + this.node.id)
        if (el) {
          let scrollscreen = document.getElementsByClassName("q-splitter__before")[0]
          scrollscreen.scrollTop = 0
          scrollscreen.scrollTop = el.getBoundingClientRect().top - 110;
        }
      }
    },
    tableInView: function (obj) {
      if (obj.isIntersecting) {
        this.$emit('tableVisible', this.node.id)
      }
    },
    childInView: function (id) {
      this.$emit('tableVisible', id)
    }
  },
  watch: {
    "$route"(to) {
      this.scrollToHash(to)
    },
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    }
  },
}
</script>

<style scoped lang="scss">
.section_heading__border {
  border-right: 10px $orange solid;
  border-bottom: 1px solid $orange;
  padding: 5px 10px 5px;
  text-align: right;
}

.presentation_label {
  border-bottom: 1px solid $teal;
}

.dummy_table {
  min-height: 200px;
}

.alerting {
  animation: blink 500ms;
  animation-iteration-count: 2;
  background-color: transparent;
}

@keyframes blink {
  50% {
    background-color: $yellow-1
  }
}
</style>
